package com.company.testaddon;

import com.company.testaddon.entity.Store;
import com.company.testaddon.test_support.AppUiTestAssist;
import com.company.testaddon.view.store.StoreDetailView;
import com.company.testaddon.view.store.StoreListView;
import io.jmix.flowui.ViewNavigators;
import io.jmix.flowui.component.textfield.TypedTextField;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.model.CollectionContainer;
import io.jmix.flowui.testassist.UiTestUtils;
import io.jmix.flowui.view.ViewControllerUtils;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import static org.junit.jupiter.api.Assertions.assertEquals;

@ExtendWith({SpringExtension.class, AppUiTestAssist.class})
@SpringBootTest(classes = TstadTestConfiguration.class)
public class StoreUiTest {

    @Autowired
    ViewNavigators viewNavigators;

    @Test
    void test() {
        viewNavigators.view(StoreListView.class).navigate();
        StoreListView view = UiTestUtils.getCurrentView();
        Assertions.assertTrue(view.isVisible());

        JmixButton createBtn = UiTestUtils.getComponent(view, "createBtn");
        createBtn.click();

        StoreDetailView detailView = UiTestUtils.getCurrentView();
        TypedTextField<String> nameField = UiTestUtils.getComponent(detailView, "nameField");
        nameField.setValue("Test 1");

        JmixButton saveAndCloseBtn = UiTestUtils.getComponent(detailView, "saveAndCloseBtn");
        saveAndCloseBtn.click();

        Assertions.assertEquals(StoreListView.class, UiTestUtils.getCurrentView().getClass());

        view = UiTestUtils.getCurrentView();
        CollectionContainer<Store> storesDc = ViewControllerUtils.getViewData(view).getContainer("storesDc");
        assertEquals(1, storesDc.getItems().size());
    }
}
