package com.company.testaddon;

import io.jmix.core.annotation.JmixModule;
import io.jmix.core.security.CoreSecurityConfiguration;
import io.jmix.flowui.testassist.FlowuiTestAssistConfiguration;
import org.springframework.boot.SpringBootConfiguration;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Import;
import org.springframework.context.annotation.Primary;
import org.springframework.context.annotation.PropertySource;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseBuilder;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseType;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;

import javax.sql.DataSource;

@SpringBootConfiguration
@EnableAutoConfiguration
@Import({TstadConfiguration.class, FlowuiTestAssistConfiguration.class,})
@PropertySource("classpath:/com/company/testaddon/test-app.properties")
@JmixModule(id = "com.company.testaddon.test", dependsOn = TstadConfiguration.class)
public class TstadTestConfiguration {

    @Bean
    @Primary
    DataSource dataSource() {
        return new EmbeddedDatabaseBuilder()
                .generateUniqueName(true)
                .setType(EmbeddedDatabaseType.HSQL)
                .build();
    }

    @EnableWebSecurity
    protected class CoreSecurity extends CoreSecurityConfiguration {
    }
}
